// cap_sts.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "cusb2.h"
#include <tlhelp32.h>
#include <io.h>

#include "BonTsEngine/TsPacketParser.h"
#include "BonTsEngine/TsDescrambler.h"
#include "BonTsEngine/FileWriter.h"
#include "BonTsEngine/TsServiceSelect.h"

#include "BonTsEngine/NetworkSend.h"

#include "BonTsEngine/EcmDat.h"

#pragma warning( disable : 4996)

//#define DEBUG_FW
//#define TS_BACK
#define S_MARGIN	(-30)		// ^Jn}[W
#define SE_MARGIN	(-40)		// ~v}[W
#define E_MARGIN	(+30)		// ^I}[W
#define APPVER		"sea(007)"

#ifdef DEBUG_FW
u8 fw_iic[1024*8];
#else
u8 fw_iic[]=
#include "fw.inc"
#endif

#define CMD_EP6IN_START		0x50	//
#define	CMD_EP6IN_STOP		0x51	//
#define	CMD_EP2OUT_START	0x52	//
#define	CMD_EP2OUT_STOP		0x53	//
#define	CMD_PORT_CFG		0x54	//addr_mask, out_pins
#define	CMD_REG_READ		0x55	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56	//addr, value
#define	CMD_PORT_READ		0x57	//(return 1byte)
#define	CMD_PORT_WRITE		0x58	//value
#define	CMD_IFCONFIG		0x59	//value
#define	CMD_MODE_IDLE		0x5a
#define CMD_EP4IN_START		0x5b	//
#define	CMD_EP4IN_STOP		0x5c	//
#define	CMD_IR_CODE			0x5d	//val_l, val_h

#define BUF_LEN	(1024*64)
#define	QUE_NUM	16

#define	PIO_START	0x20
#define	PIO_IR_OUT	0x10
#define	PIO_IR_IN	0x08
#ifdef TS_BACK
#define PIO_TS_BACK	0x04
#endif

cusb2 *usb;
cusb2_tcb *tcb1;
cusb2_tcb *tcb2;

LONG cmd_len=0,ret_len=0;
u8	cmd[64];
u8  ret[64];
CCyUSBEndPoint *inep;
CCyUSBEndPoint *outep;

#define BCAS_PRE_TIME	0
#define BCAS_POST_TIME	0

ULONG buffer_margin;	// TSXg[obt@}[W
ULONG buffer_size;		// TSXg[obt@TCY

time_t start_time = 0;
time_t end_time = 0;
bool bcas = false;
bool network = false;
bool force_poff = false;
bool force_pon = true;
bool file_name_no_change = false;
bool bdiag = false;
FILE *wfp;
FILE *wfp2;

// d
bool pon = false;
bool poff = false;

// wT[rXL^
bool bSel = false;
int  service = 0;
char szCh[10];

// M`FbN
bool bRecvChk = false;
HANDLE hRecvChkTh = NULL;
// MɃ`l蒼̂łɈړ
u16 ir_cmd[16];
s32 ir_cmd_num = 0;

// B25,NULLpPbgp
bool bB25 = false;
CTsPacketParser* pTSPacketParser;
CTsDescrambler* pTsDescrambler;
CTsServiceSelect* pTsServiceSelect;
CFileWriter* pFileWriter;
CNetworkSend* pNetworkSend;
CRingBuffer *pTsBuf;

CEcmDat* pEcm;

// cap_sts̒~
HANDLE hStopEvent = NULL;
bool bStopEventRecv = false;
bool bStop = FALSE;
char logfilename[256];
char appname[256];
char execname[256];
char eventname[256];

// cap_sts̃R}h󂯕t
HANDLE hCmdThread = NULL;
bool bCmdThreadStop = false;
char cmdMapName[256];
char cmdReqEventName[256];
char cmdResEventName[256];
typedef struct {
	BYTE	cmd;
	int		add;
	time_t	end_time;
	char szCh[10];
} SHARED_DATA;
#define CMD_ADD_MIN		1
#define RES_ADD_MIN		101
#define CMD_GET_TIME	2
#define RES_GET_TIME	102
#define CMD_CHG_CN		3
#define RES_CHG_CN		103

#define VLC_INI_FILE	".\\setting_vlc.ini"

void log_out(const char* szFormat, ...)
{
	va_list Args;
	TCHAR szTempStr[4096];

	va_start(Args , szFormat);
	vsprintf(szTempStr, szFormat, Args);
	va_end(Args);

	printf(szTempStr);
	
	FILE *fout;
	if(!fopen_s(&fout, logfilename, "a+t")){
		time_t now = time(NULL);
		fwrite(szTempStr,strlen(szTempStr),1,fout);
		fclose(fout);
	}
}


bool write_func(u8 *buf, u32 len){
	time_t now;

	time( &now );							//bPʂŎ擾

	// IvIB
	if(WaitForSingleObject(hStopEvent,0) == WAIT_OBJECT_0) {
		ResetEvent(hStopEvent);
		// M̏ꍇ͎oCxgł\̂Ŗ
		if(bRecvChk) {
			log_out("Iv󂯂̂ŏI܂B\n");
			bStopEventRecv = true;
			end_time = now;			// bsco͂~邽
			pEcm->exit();
		}
	}
	bRecvChk = true;

	if(now < start_time && !bStopEventRecv) return true;		//BCASɋL^
/*
	// fR[_Otɓ
	if(!pTSPacketParser->InputMedia(new CMediaData(buf, len))){
		log_out("fR[hɃG[܂B\n");
	}
*/
	pTsBuf->set(buf,len);
//	TRACE1("Buffer: %d bytes",pTsBuf->size());

	if(now < end_time && !bStopEventRecv) return true;			//IԁH

	cmd[cmd_len++]=CMD_EP6IN_STOP;
	if(bcas == false) 
		cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}



bool write_bcas(u8 *buf, u32 len){
	time_t now;

	time( &now );			//bPʂŎ擾

//	fwrite(buf,1,len,wfp2);

	pEcm->set(buf,len);

	if(now < end_time + BCAS_POST_TIME) return true;

	cmd[cmd_len++]=CMD_EP4IN_STOP;
	cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}

void ir_cmdtx(u16 *ircmd, s32 n){
	s32 i;
	s32 ir_wait = 600;
	for(i=0; i<n; i++){
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=(u8)ircmd[i];
		cmd[cmd_len++]=(u8)(ircmd[i] >> 8);
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		if(ircmd[i] == 0x04d8) 
			ir_wait = 300;	//3digit
		Sleep(ir_wait);
		//IRo͒~
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=0;
		cmd[cmd_len++]=0;
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		Sleep(100);
	}
}

// Jn2bĂf[^MȂꍇ͓dONƃ`ls
void recvchkthread_proc(void *para) {
	Sleep(2000);
	if(bRecvChk)
		return;
	log_out("f[^MȂ̂œdONs܂B\n");
	u16 cmd[16];
	s32 cmd_num = 0;
	cmd[cmd_num++] = 0x048b;								//dON
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	ir_cmdtx(cmd, cmd_num);
	//`lݒ
	if(ir_cmd_num != 0)
		ir_cmdtx(ir_cmd, ir_cmd_num);

	if(bB25)
		pTsDescrambler->Reset();
}

void cmdThread_proc(void *para)
{
	HANDLE hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
	while(!bCmdThreadStop) {
		if(WaitForSingleObject(hCmdReqEvent,0) == WAIT_OBJECT_0) {
			ResetEvent(hCmdReqEvent);
			HANDLE hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);

			HANDLE hMap; /* t@C}bsOIuWFNg̃nh */
			SHARED_DATA	 *pData; /* Lf[^ */

			/* t@C}bsOIuWFNg̍쐬 */
			hMap = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE,cmdMapName);

			if(hMap != NULL) {
				/* r[̍쐬 */
				pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
				if(pData->cmd == CMD_ADD_MIN) {
					pData->cmd = RES_ADD_MIN;
					end_time += (pData->add * 60);
					pData->end_time = end_time;
					struct tm* stm = localtime(&end_time);
					log_out("%d  %02d:%02d:%02d ܂ŋL^܂B\n",pData->add,stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				else if(pData->cmd == CMD_GET_TIME) {
					pData->cmd = RES_GET_TIME;
					pData->end_time = end_time;
				}
				UnmapViewOfFile(pData);
				CloseHandle(hMap);
			}
			SetEvent(hCmdResEvent);
			CloseHandle(hCmdResEvent);
		}
		ULONG size;
	
		size = pTsBuf->size();
		if(size > buffer_margin){
			size -= buffer_margin;
			BYTE* buff = new BYTE[size];
			// fR[_Otɓ
//			TRACE1("Parse: %d bytes\n",size);
//			TRACE1("Read:%d ",pTsBuf->read());
//			TRACE1("Write:%d ",pTsBuf->write());
//			TRACE1("Max:%d \n",pTsBuf->max_size());
			pTsBuf->get(buff,size);			
			pTsBuf->flash(size);

			CMediaData* data = new CMediaData(buff, size);
	
			if(!pTSPacketParser->InputMedia(data)){
				log_out("fR[hɃG[܂B\n");
			}

			data->Delete();

	
			delete [] buff;
	
		} else {
	//		TRACE0("Buffer Empty\n");
			Sleep(300);
		}

	}
	CloseHandle(hCmdReqEvent);
}

//////////////////////////////////////////////////////////////////////////////
//VLCN֘A

STARTUPINFO m_si;
PROCESS_INFORMATION m_pi;

// EBhEnh擾AvP[VIB
BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam)
{
    // CreateProcess()Ŏ擾PROCESS_INFORMATION\̂̃|C^擾
    PROCESS_INFORMATION* pi = (PROCESS_INFORMATION*)lParam;

    // EChE쐬vZXID擾B
    DWORD lpdwProcessId = 0;
    ::GetWindowThreadProcessId(hWnd, &lpdwProcessId);

    // CreateProcessŋNAṽvZXIDƃCEBhE
    // 쐬vZXIDꍇANAvIB
    if(pi->dwProcessId == lpdwProcessId)
    {
        ::SendMessage(hWnd, WM_CLOSE, 0, 0);
        return TRUE;
    }
    return TRUE;
}

	
bool OpenVlc(LPSTR vlc)
{
	// VLC̋NB
	::ZeroMemory(&m_si, sizeof(STARTUPINFO));
	m_si.cb           = sizeof(STARTUPINFO);
	m_si.dwFlags      = STARTF_USESHOWWINDOW;
	m_si.wShowWindow  = SW_SHOWNORMAL;
	::CreateProcess(NULL, vlc, NULL, NULL, FALSE, 0, NULL, NULL, &m_si, &m_pi);

	return TRUE;
}

void CloseVlc(void)
{
	// R[obN֐̌ĂяoB
	EnumWindows(EnumWindowsProc, (LPARAM)&m_pi);

	// I܂őҋ@A5b҂ĂIȂ͋IB
	if(::WaitForSingleObject(m_pi.hProcess, 5000) == WAIT_TIMEOUT){
		TerminateProcess(m_pi.hProcess, 0);
	}
}

//////////////////////////////////////////////////////////////////////////////
//X^oC

int term_commit;

#define STANDBY_DLG_CAPTION		_T("standby notice")

BOOL CALLBACK EnumWindowsProcMessageBox(HWND hWnd, LPARAM lParam)
{
	char className[256];

	GetWindowText(hWnd, className, 256);

	if(strcmp(className,STANDBY_DLG_CAPTION) == 0){

       ::SendMessage(hWnd, WM_CLOSE, 0, 0);
	}
        return TRUE;
}


DWORD WINAPI MonitorThread(LPVOID lpParam)
{
	
	term_commit = MessageBoxA(NULL,"10bStandByɈڍs܂B",STANDBY_DLG_CAPTION,MB_OKCANCEL|MB_ICONWARNING|MB_TOPMOST);

	return TRUE;
}

void DoSuspend(void)
{

	char buff[256];
	GetPrivateProfileString("POWER","STANDBY","OFF",buff,sizeof(buff),VLC_INI_FILE);

	if(strcmpi(buff, "ON") == 0){		// StandBys
		DWORD dwThreadId;

		HANDLE hThread = CreateThread(NULL,0,MonitorThread,0,0,&dwThreadId); 

		int i;

		term_commit = -1;
		for(i = 0 ; i < 20 ; i ++){
			if(term_commit != -1) break;
			Sleep(500);
		}

		EnumWindows(EnumWindowsProcMessageBox, NULL);

		if(term_commit == IDCANCEL && i != 20){
			return;
		}

		BOOL sus,force;
		GetPrivateProfileString("POWER","fSuspend","1",buff,sizeof(buff),VLC_INI_FILE);
		sus = atoi(buff);
		GetPrivateProfileString("POWER","fForce","0",buff,sizeof(buff),VLC_INI_FILE);
		force = atoi(buff);

		HANDLE hToken;
		TOKEN_PRIVILEGES tknPrvlgs;

		OpenProcessToken(GetCurrentProcess(),
						 TOKEN_ADJUST_PRIVILEGES, &hToken);
		LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME,
							 &(tknPrvlgs.Privileges[0].Luid));
		tknPrvlgs.PrivilegeCount = 1;
		tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		AdjustTokenPrivileges(hToken, FALSE, &tknPrvlgs, 0, NULL, NULL);
		SetSystemPowerState(sus,force);
	}
}

//////////////////////////////////////////////////////////////////////////////
//^IɓƎR}hs

string& replace(string& str, const string sb, const string sa)
{
	string::size_type n, nb = 0;
	
	while ((n = str.find(sb,nb)) != string::npos)
	{
		str.replace(n,sb.size(),sa);
		nb = n + sa.size();
	}
	
	return str;
}

void DoAfterCommand(LPCTSTR tsname,LPCTSTR vlcparm)
{
	char buff[256],buff2[16];
	int i,j;
	string arg;

	char drv[256],path[256],name[256],ext[256];
	_splitpath(tsname,drv,path,name,ext);

	for(j = 0 ; j < 2 ; j ++){
		for(i = 1 ; ; i ++){
			sprintf(buff2,"cmd%d",i);
			if(j == 0){
				GetPrivateProfileString("COMMAND_AFTER",buff2,"",buff,sizeof(buff),VLC_INI_FILE);
				if(buff[0]==NULL) break;
			} else {
				if(vlcparm[0] == NULL) break;
				
				char buff3[256];
				sprintf(buff3,"COMMAND_AFTER_%s",vlcparm);
				GetPrivateProfileString(buff3,buff2,"",buff,sizeof(buff),VLC_INI_FILE);				
				if(buff[0]==NULL) break;
			}
			arg = buff;
			replace(arg,string("%FILE%"),string(tsname));
			replace(arg,string("%DRV%"),string(drv));
			replace(arg,string("%PATH%"),string(path));
			replace(arg,string("%NAME%"),string(name));
			replace(arg,string("%EXT%"),string(ext));

			if(buff[0] == NULL) break;

			::ZeroMemory(&m_si, sizeof(STARTUPINFO));
			m_si.cb           = sizeof(STARTUPINFO);
			m_si.dwFlags      = STARTF_USESHOWWINDOW;
			m_si.wShowWindow  = SW_SHOWNORMAL;
			log_out("cmd : %s",arg.c_str());
			::CreateProcess(NULL, (LPSTR)arg.c_str(), NULL, NULL, FALSE, 0, NULL, NULL, &m_si, &m_pi);
			::WaitForSingleObject(m_pi.hProcess, INFINITE);
		}
	}

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//IɁA`[i[POFFɂB

void ForcePoff(u8 fx2id)
{
	usb = new cusb2(NULL);
	int retry_cnt = 0;
RETRY:
	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_KAI3"/*NULL*/))
	{
		u16 ir_post_cmd[16];
		s32 ir_post_cmd_num = 0;

		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);
		
		ir_post_cmd[ir_post_cmd_num++] = 0x048c;					//dOFF
		ir_cmdtx(ir_post_cmd, ir_post_cmd_num);
	} else {
		if(retry_cnt++ < 6){
			Sleep(3000);
			goto RETRY;
		}
	}

	delete usb;
}

void ForcePon(u8 fx2id)
{
	usb = new cusb2(NULL);
	int retry_cnt = 0;
RETRY:

	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_KAI3"/*NULL*/))
	{
		u16 ir_cmd[16];
		s32 ir_cmd_num = 0;

		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);
		
		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;					//no addr(addr_mask)
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//out_pins  
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START,IR_OUT(out_pins)
#endif
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;			//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h

		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

		ir_cmd[ir_cmd_num++] = 0x048b;								//dON
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;
		ir_cmd[ir_cmd_num++] = 0;

		ir_cmdtx(ir_cmd, ir_cmd_num);
	} else {
		if(retry_cnt++ < 6){
			Sleep(3000);
			goto RETRY;
		}
	}

	delete usb;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//NOɁAcap_stsȂmFB

void ChkAnotherCapsts(void)
{
	// ^XNXgQƂAȊOcap_stsȂׂ
	BOOL bFast = TRUE;
	BOOL bEventSend = TRUE;
	DWORD hMyProcessId = GetCurrentProcessId();
	int mode = 0;
	while(1) {
		HANDLE	hProcessSnap = NULL;
		PROCESSENTRY32   pe32;
		BOOL    bRet = FALSE;
		ZeroMemory ( &pe32, sizeof (pe32) );

		hProcessSnap = CreateToolhelp32Snapshot ( TH32CS_SNAPPROCESS, 0);
		if ( INVALID_HANDLE_VALUE == hProcessSnap ) {
			break;
		}
	
		// Jn\莞SE_MARGINbOɂȂĂ~Ȃꍇ͑Ocap_sta~
		if((start_time+SE_MARGIN) <= time(NULL) || bStop)
			mode++;

		BOOL bExec = FALSE;
		pe32.dwSize = sizeof ( PROCESSENTRY32 );
		bRet = Process32First ( hProcessSnap, &pe32 );
		if ( bRet ) {
			do {
				// cap_sts.exe𔭌
				if(strcmpi(pe32.szExeFile,execname) == 0) {
					// ł͖
					if(pe32.th32ProcessID != hMyProcessId) {
						bExec = TRUE;
						if(mode == 1 && bEventSend) {
							// 悸EventgďIv NłSetEvent͈̂
							hStopEvent = OpenEvent(EVENT_MODIFY_STATE,FALSE,eventname);
							SetEvent(hStopEvent);
							log_out("s̕%s֏Iv𑗐M܂B\n",appname);
							CloseHandle(hStopEvent);
							bEventSend = FALSE;
						}
#if 0
						else if(mode == 3) {
							// łIȂꍇ͋I
							HANDLE process_handle;
							process_handle = OpenProcess(PROCESS_TERMINATE, FALSE, pe32.th32ProcessID);
							if( process_handle ) {
								TerminateProcess(process_handle, 0);
								log_out("s̕%s~܂B\n",appname);
								CloseHandle(process_handle);
							}
						}
#endif
					}
				}
			} while ( Process32Next ( hProcessSnap, &pe32 ) );
		}
		CloseHandle ( hProcessSnap );

		if(!bExec || mode > 4)
			break;

		if(bFast && !bStop && bEventSend) {
			log_out("ʂ%s쒆łBÎ҂܂B\n",appname);
			bFast = FALSE;
		}
		Sleep(1000);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//B25֌WAI

void B25Init(void)
{
	// B25p
	pTSPacketParser = new CTsPacketParser(NULL);
	pTsDescrambler = new CTsDescrambler(NULL);
	pTsServiceSelect = new CTsServiceSelect();
	pFileWriter = new CFileWriter(NULL);
	pNetworkSend = new CNetworkSend(32767);
	pTsServiceSelect->SetServiceId(service);

	pTsBuf = new CRingBuffer(buffer_size);
	pEcm = new CEcmDat();


	if(network)
		pNetworkSend->Open("localhost",1234);

	// B25gpꍇ pTSPacketParser -> pTsDescrambler -> pFileWriter ƂȂ
	if(bB25) {
		// B-CASJ[hI[v
		if(!pTsDescrambler->OpenBcasCard()){
			log_out("B-CASJ[h̃I[vɎs܂B\n");
			bB25 = FALSE;
		}
		else {
			if(bSel) {
				pTSPacketParser->SetOutputDecoder(pTsServiceSelect);
				pTsServiceSelect->SetOutputDecoder(pTsDescrambler);
				if(network){
					pTsDescrambler->SetOutputDecoder(pNetworkSend);
				} else {
					pTsDescrambler->SetOutputDecoder(pFileWriter);
				}
			}
			else {
				pTSPacketParser->SetOutputDecoder(pTsDescrambler);
				if(network){
					pTsDescrambler->SetOutputDecoder(pNetworkSend);
				} else {
					pTsDescrambler->SetOutputDecoder(pFileWriter);
				}
			}
		}
	}
	// B25gpȂꍇB-CASJ[hI[vɎsꍇ pTSPacketParser -> pFileWriter ƂȂB
	if(!bB25) {
		if(bSel) {
			pTSPacketParser->SetOutputDecoder(pTsServiceSelect);
			pTsServiceSelect->SetOutputDecoder(pFileWriter);
		}
		else {
			pTSPacketParser->SetOutputDecoder(pFileWriter);
		}
	}
}

void B25Exit(void)
{
	delete pTSPacketParser;
	delete pTsServiceSelect;
	delete pTsDescrambler;
	delete pFileWriter;
	delete pNetworkSend;
	delete pTsBuf;
	delete pEcm;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Cu
int Is2ByteChar(unsigned char c)
{
    int esc = 0; /* ŏIoCg̏ */
    int rtn = 0; /* ԋpl */
	
	if (esc == 0) { /* ESCȊO */
		if ((c >= 0x20) && (c <= 0x7E)) {
			/* ASCII */
		} else if ((c <= 0x06) || (c == 0x7f) || (c == 0xff)) {
			rtn = 1; /* Binary */
		} else if (c == 0x1B) {
			esc = 1; /* ESC (1B) */
			rtn = 1; /* Not ASCII */
		} else if ((c >= 0x07) && (c <= 0x0d)) {
			/* ctrl */
		} else if ((c >= 0x0e) && (c <= 0x1F)) {
			rtn = 0; /* Binary */
		} else if (((c >= 0x80) && (c <= 0x8D))
			|| ((c >= 0x90) && (c <= 0xA0))) {
			rtn = 1; /* SJIS */
		} else if (c == 0xFE) {
			rtn = 1; /* EUC */
		} else {
			rtn = 0; /* Not ASCII */
		}
	} else if (esc == 1) { /* ESC (1B) */
		if (c == 0x24) {
			esc = 1; /* ESC (1B 24) */
		} else if (c == 0x28) {
			esc = 1; /* ESC (1B 28) */
		} else {
			esc = 0;
		}
	} else if (esc == 2) { /* ESC (1B 24) */
		esc = 0;
		if ((c == 0x40) || (c == 0x42)) {
			rtn = 1; /* JIS */
		}
		
	} else { /* ESC (1B 28) */
		esc = 0;
		if ((c == 0x42) || (c == 0x49) || (c == 0x4A)) {
			rtn = 1; /* JIS */
		}
	}
	
    return(rtn);
}



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//C

using namespace std;
#include <string>

static const char *def_tsfname = "test.ts2";

int _tmain(int argc, _TCHAR* argv[])
{
	s32 i;
	s32 sleep=0;
	time_t now;
	char *tsfname = NULL, tsfname_buf[256];
	u8 fx2id = 0;
	u16 ir_post_cmd[16];
	s32 ir_post_cmd_num = 0;

	buffer_size = 1024*1024*20;
	buffer_margin = 1024*1024*16;

#ifdef DEBUG_FW
	FILE *fp;
	fopen_s(&fp, "fw\\fifo.iic","rb");
	//fopen_s(&fp, "fw\\fifo_sdcc.iic","rb");
	fread(fw_iic, 1, sizeof(fw_iic), fp);
#endif
	u32 cap_mb = 10;

	// Op̃t@C쐬
	char szModulePath[256],drv[10],path[256],ext[256];
	char vlc_param[256];
	vlc_param[0] = NULL;
	GetModuleFileName(NULL,szModulePath,256);
	_splitpath(szModulePath,drv,path,appname,ext);
	_makepath(logfilename,drv,path,appname,".log");
	_makepath(execname,NULL,NULL,appname,ext);
	sprintf(eventname,"%s_stopeventname",appname);
	sprintf(cmdMapName,"%s_cmdMapFileName",appname);
	sprintf(cmdReqEventName,"%s_cmdReqEventName",appname);
	sprintf(cmdResEventName,"%s_cmdResEventName",appname);

	// p[^sɂ邽߈ꎞޔ
	char szCh[10];
	memset(szCh,0,10);

	time( &now );			//bPʂŎ擾
	if(argc == 1){
		printf("g %s\n",APPVER);
		printf("%s [t@C] [@`l] [] [B] [Il]\n",appname);
		printf("  t@CFgqȗ\".ts2\"Bt@Cȗ\"test.ts2\"B\n");
		printf("              t@C㕔ɁA\"_N_b_@`l\"t܂B\n");
		printf("  P         FJnɓdONsB\n");
		printf("  POFF      FIɓdOFFs(O̒~͍sȂB\n");
		printf("  `lFnfW\"@1\"`\"@12\"BBS\"@B3\"ACS\"@C2\"A3wB\n");
		printf("        Fl\"30\"ŋL^()B\"19:00-19:30\"ŎwB\n");
		printf("  B or B25  FB-CAS[_gAB25s܂B\n");
		printf("  Il     FΏۂ̃JIFX2IDwBȗ0B\n");
		printf("  SEL       FnfWł̓f[^̍폜s܂B\n");
		printf("              BS/CSCH3wsꍇ͎w`l̃T[rX݂̂\n");
		printf("              L^܂B\n");
		printf("  STOP      Fݓ쒆%sɏIvo܂(^擙͍s܂)\n",appname);
		printf("  ADD     Fݓ쒆%s̏IԂw蕪܂\n",appname);
		printf("  vlc:[parm]FvlcoRŘ^悵܂B(BIvVK{) \n");
		printf("            @[parm]̗:MP2_PS,WMV_LITEBsetting_vlc.iniŏڍאݒ\B\n");
		printf("\ngp၄\n");
		printf("ucap_sts j[X @B101 30v BS101\"j[X.ts2\"ō쐬BL^Ԃ30B\n");
		printf("ucap_sts 19:00-19:30 Bv `l19:00-19:30\"test.ts2\"\n");
		exit(-1);
	}
	else{
		// ^XNspɃOɎc
		struct tm *ntm = localtime(&now);
		log_out("%04d/%02d/%02d %02d:%02d:%02d %sJn %s\n",ntm->tm_year+1900,ntm->tm_mon+1,ntm->tm_mday,ntm->tm_hour,ntm->tm_min,ntm->tm_sec,appname,APPVER);
		for(i=0; i<argc; i++)
			log_out("%s ",argv[i]);
		log_out("\n");
		for(i=1; i<argc; i++){
			BOOL time_check = TRUE;
			DWORD str_ptr;
			for(str_ptr = 0;argv[i][str_ptr] != NULL ; str_ptr++) {
				if(
					!(
					(argv[i][str_ptr] >= '0') && (argv[i][str_ptr]) <= '9' ||
					(argv[i][str_ptr] == ':') || 
					(argv[i][str_ptr] == '-')
					)
				){
					time_check = FALSE;
					break;
				}
			}
			if(time_check) {
				//
				if(strchr(argv[i], ':')!=NULL){//nn:nnw
					struct tm *nt;
					s32 st_h,st_m,en_h,en_m;
					nt = localtime( &now );	// tm \̌`ɕϊ
					if(sscanf(argv[i], "%d:%d-%d:%d", &st_h, &st_m, &en_h, &en_m) == 4){//폈
						if((st_h * 60 + st_m) < (nt->tm_hour * 60 + nt->tm_min)){
							//Ȃ̂24Ԓǉ
							st_h += 24;
							en_h += 24;
						}
						if((st_h * 60 + st_m) > (en_h * 60+ en_m))
							//It܂̂
							en_h += 24;
						//bH
						sleep = (st_h * 60*60 + st_m * 60) - (nt->tm_hour * 60*60 + nt->tm_min * 60 + nt->tm_sec);
						end_time = now + sleep + ((en_h * 60*60 + en_m * 60) - (st_h * 60*60 + st_m * 60));
						int min = (en_h * 60 + en_m) - (st_h * 60 + st_m);
						st_m = sleep - (sleep/(60*60))*(60*60);
						log_out("%2.2d:%2.2d:%2.2d bォ%2.2d:%2.2d ԋL^܂B\n", sleep/(60*60), st_m/60 , sleep%60, min/60, min%60);
					}
				}
				else{
					char *s;
					int min = strtol(argv[i], &s, 10);
					end_time = now + min*60;
					log_out("ݎ%2.2d:%2.2d ԋL^܂B\n", min/60, min%60);
				}
			}
			else if(argv[i][0] == '@'){
				// `lw
				strcpy(szCh,argv[i]);
			}
			else if(strcmpi(argv[i], "b") == 0){
				//BCASOw
				bcas = true;
				bB25 = true;		// B25LɂB
			}
			else if(argv[i][0] == 'v' && argv[i][1] == 'l' && argv[i][2] == 'c' && argv[i][3] == ':'){
				//Networko
				network = true;
				strcpy(vlc_param,&argv[i][4]);
			}
			else if(strcmpi(argv[i], "b25") == 0){
				//B25w
				bcas = true;		// B-CASLɂB
				bB25 = true;
			}
			else if(strcmpi(argv[i],"fpoff") == 0){
				force_poff = true;
			}
			else if(strcmpi(argv[i],"fpon") == 0){
				force_pon = true;
			}
			else if(strcmpi(argv[i],"fn") == 0){
				file_name_no_change = true;
			}
			else if(strcmpi(argv[i], "p") == 0){
				//JnPONw
				ir_cmd[ir_cmd_num++] = 0x048b;								//dON
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
			}
			else if(strcmpi(argv[i], "poff") == 0){
				ir_post_cmd[ir_post_cmd_num++] = 0x048c;					//dOFF
				poff = true;
			}
			else if(strcmpi(argv[i], "stop") == 0){
				//Ivw
				bStop = true;
			}
			else if(strcmpi(argv[i], "sel") == 0){
				//T[rXI
				bSel = true;
			}
			else if(strcmpi(argv[i], "bdiag") == 0){
				//B-CAS Xg[}[WmF[h
				//pEcm->SetDiag(TRUE);
				bdiag = TRUE;
			}
			else if(strcmpi(argv[i], "add") == 0){
				//R}hM
				HANDLE hMap = CreateFileMapping(
					(HANDLE)-1,
					NULL,
					PAGE_READWRITE,
					0, sizeof(SHARED_DATA), 
					cmdMapName);

				SHARED_DATA* pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));

				if(i+1 < argc) {
					pData->cmd = CMD_ADD_MIN;
					pData->add = atoi(argv[i+1]);
				}
				else {
					pData->cmd = CMD_GET_TIME;
				}

				UnmapViewOfFile(pData);
				
				HANDLE hCmdReqEvent = CreateEvent(NULL,FALSE,FALSE,cmdReqEventName);
				HANDLE hCmdResEvent = CreateEvent(NULL,FALSE,FALSE,cmdResEventName);
				SetEvent(hCmdReqEvent);
				CloseHandle(hCmdReqEvent);
				WaitForSingleObject(hCmdResEvent,1000);
				ResetEvent(hCmdResEvent);
				CloseHandle(hCmdResEvent);
				pData = (SHARED_DATA *)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(SHARED_DATA));
				if(pData->cmd == RES_ADD_MIN) {
					struct tm* stm = localtime(&pData->end_time);
					log_out("%d  %02d:%02d:%02d ܂ŋL^܂B\n",pData->add,stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				else if(pData->cmd == RES_GET_TIME) {
					struct tm* stm = localtime(&pData->end_time);
					log_out("%02d:%02d:%02d ܂ŋL^܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);
				}
				UnmapViewOfFile(pData);
				CloseHandle(hMap);
				return 0;
			}
			else if((argv[i][0] == 'i' || argv[i][0] == 'I')&&(isdigit(argv[i][1]))&&(argv[i][2]==0)){
				//JFX2@IDw
				char *s;
				fx2id = (u8)strtol(argv[i]+1, &s, 10);
				log_out("^[Qbg̃JIUSB FX2ID %d ɐݒ肵܂B\n", fx2id);
			}
			else{
				//t@C
				tsfname = tsfname_buf;
				strcpy(tsfname, argv[i]);
				if(strchr(tsfname, '.') == NULL){
					strcat(tsfname, ".ts2");
				}
			}
		}
	}

	if(szCh[0] != 0x00) {
		_mbslwr((unsigned char *)szCh);
		//`l
		int n = 2;
		log_out("`l[");
		if(szCh[1] == 'b'){
			//BS
			buffer_size = GetPrivateProfileInt("TS_BUFFER","BS",10,VLC_INI_FILE) * 1024 * 1024;
			log_out("BS");
			ir_cmd[ir_cmd_num++] = 0x04e2;					//BS
			if((szCh[3]==0)||(szCh[4]==0)){
				if(szCh[3] != 0){//10,11,12ch
					n = 4;
					log_out("%s", szCh+2);
					if(szCh[3] == '0')
						ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
					else
						ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[3] - '1');	//11,12ch
				}
				else{
					n = 2;
				}
			}
			else{
				ir_cmd[ir_cmd_num++] = 0x04d8;					//3-digit
				service = atoi(&szCh[2]);
			}
		}
		else if(szCh[1] == 'c'){
			//CS
			buffer_size = GetPrivateProfileInt("TS_BUFFER","CS",20,VLC_INI_FILE) * 1024 * 1024;
			log_out("CS");
			ir_cmd[ir_cmd_num++] = 0x04e3;					//CS
			if((szCh[3]==0)||(szCh[4]==0)){
				if(szCh[3] != 0){//10,11,12ch
					n = 4;
					log_out("%s", szCh+2);
					if(szCh[3] == '0')
						ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
					else
						ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[3] - '1');	//11,12ch
				}
				else{
					n = 2;
				}
			}
			else{
				ir_cmd[ir_cmd_num++] = 0x04d8;					//3-digit
				service = atoi(&szCh[2]);
			}
		}
		else{
			//nfW
			buffer_size = GetPrivateProfileInt("TS_BUFFER","CHIDEZI",10,VLC_INI_FILE) * 1024 * 1024;
			log_out("nfW");
			ir_cmd[ir_cmd_num++] = 0x04d6;					//n
			ir_cmd[ir_cmd_num++] = 0;
			if(szCh[2] != 0){//10,11,12ch
				n = 3;
				log_out("%s", szCh+1);
				if(szCh[2] == '0')
					ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
				else
					ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[2] - '1');	//11,12ch
			}
			else{
				n = 1;
			}
		}
		while(szCh[n] != 0){
			log_out("%c",szCh[n]);
			ir_cmd[ir_cmd_num++] = 0x0480 + (szCh[n] - '0');	//num
			n++;
		}
		log_out("]\n");
		buffer_margin = buffer_size * GetPrivateProfileInt("TS_BUFFER","MARGIN_RATE",80,VLC_INI_FILE) / 100;
	}

	//// T[rXNo0(ݒ)̏ꍇSELtONAB
	//if(service == 0)
	//	bSel = false;

	start_time = now + sleep;
	// 30bO^Jn悤ɕύX
	if(sleep != 0){
		sleep = sleep+S_MARGIN;
		if(sleep < 0) sleep = 0;
	}
	if(bcas){
		//BCASL^
		if(sleep != 0){
			sleep -= BCAS_PRE_TIME;
			if(sleep < 0) sleep = 0;
		}
		else{
			start_time += BCAS_PRE_TIME;
		}
	}
	if(end_time == 0 && !bStop) {
		end_time = start_time + 20;	//ftHgL^Ԃ20b
		log_out("%d bォ%d bԋL^܂B\n", (int)(start_time - now), (int)(end_time - start_time));
	}
	else {
		// 30b]vɘ^悵܂B
		end_time = end_time+E_MARGIN;
	}

	time_t echktime = time(NULL);

	ChkAnotherCapsts();		// cap_stsȂmFB֐B狭~B

	// p[^"stop"w肳Ăꍇ͂ŏI
	if(bStop){
		if(force_poff){
			ForcePoff(fx2id);
		} else if (force_pon){
			ForcePon(fx2id);
		}
		return 0;
	}

	// cap_stsI҂sleep}CiXB
	time_t echktime2 = time(NULL);
	sleep -= (s32)(echktime2-echktime);
	if(sleep < 0)
		sleep = 0;
	// cap_sts̏Iv󂯂邽߂̃Cxg쐬
	hStopEvent = CreateEvent(NULL,FALSE,FALSE,eventname);

	//if(end_time - start_time > 60*3){
	//	printf("Jpo[Ŵ߁AL^Ԃ3ɐ܂B\n");
	//	end_time = start_time + 60*3;
	//}


	if(tsfname == NULL) tsfname = (char *)def_tsfname;
	
	struct tm *stm = localtime(&start_time);
	{	// o̓t@Cݒ
		
		bool bFileChange = false;
		char drv[256],path[256],name[256],name2[256],ext[256],srcName[256],szEx[10];
		_splitpath(tsfname,drv,path,name,ext);
		int ptr;
		for(ptr = 0 ; name[ptr] != NULL ; ptr++){
			if(Is2ByteChar(name[ptr])){
				ptr++;
			} else {
				if(/*tsfname[ptr] == '\\' ||*/ name[ptr] == '/' || name[ptr] == ':' || name[ptr] == '?' ||		// ֑gĂꍇ
					name[ptr] == '*' || name[ptr] == '"' || name[ptr] == '<' || name[ptr] == '>' || name[ptr] == '|'){
						name[ptr] = '_';
				}
			}
		}
		if(file_name_no_change==false){
			sprintf(name2,"%s_%04d%02d%02d_%02d%02d%02d%s%s",name,stm->tm_year+1900,stm->tm_mon+1,stm->tm_mday,stm->tm_hour,stm->tm_min,stm->tm_sec,szCh[0] == 0x00 ? "":"_",szCh);
			strcpy(name,name2);
			for(int i = 0;i < 100;i++) {
				strcpy(name2,name);
				if(i == 0)
					szEx[0] = 0x00;
				else
					sprintf(szEx,"(%d)",i);
				strcat(name2,szEx);
				_makepath(srcName,drv,path,name2,ext);
				if(_access(srcName,0) != 0) {
					tsfname = srcName;
					if(i != 0)
						bFileChange = TRUE;
					break;
				}
			}
		}
		// t@Co͉\`FbN
		bool bFileError = false;
#if 0
		FILE *fchk;
		if(fopen_s(&fchk,tsfname,"wb")) {
			bFileError = true;
		}
		else {
			int dmysize = fwrite("dummy",1,5,fchk);
			if(dmysize != 5)
				bFileError = true;
			fclose(fchk);
		}
#endif
		if(bFileError) {
			struct tm *stm = localtime(&start_time);
			sprintf(name,"%s_%04d%02d%02d_%02d%02d%02d%s%s",appname,stm->tm_year+1900,stm->tm_mon+1,stm->tm_mday,stm->tm_hour,stm->tm_min,stm->tm_sec,szCh[0] == 0x00 ? "":"_",szCh);
			_makepath(srcName,drv,path,name,ext);
			tsfname = srcName;
			bFileChange = true;
		}

		if(bFileChange)
			log_out("o̓t@C%sɕύX܂B\n",tsfname);
	}

	log_out("TS Buffer Max : %d MB(margin : %d MB)\n",buffer_size/(1024*1024),buffer_margin/(1024*1024));
	int retry_cnt = 0;

	if(network){
		char buff[1024];
		GetPrivateProfileString("VLC_SETTING","VLC_PATH","C:\\Program Files\\VideoLAN\\VLC\\vlc.exe",buff,sizeof(buff),VLC_INI_FILE);
		string arg = buff;
		arg += " ";
		GetPrivateProfileString("VLC_SETTING",vlc_param,"",buff,sizeof(buff),VLC_INI_FILE);
		if(buff[0] == NULL){
			log_out("VLC_PARAM : %s Ȃ߁Audp://@ŋN܂B\n",vlc_param);
			strcpy(buff,"udp://@");
		}
		arg += buff;
				
		replace(arg,string("%FILE%"),string(tsfname));
		log_out("VLC Open:%s\n",arg.c_str());
		OpenVlc((LPSTR)arg.c_str());
	}

	usb = new cusb2(NULL);

	B25Init();
	pEcm->SetDiag(bdiag);

RETRY:
	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_KAI3"/*NULL*/))
	{
		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);

		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;					//no addr(addr_mask)
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//out_pins  
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START,IR_OUT(out_pins)
#endif
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;			//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h
		cmd[cmd_len++]=0x70;
		cmd[cmd_len++]=0x71;
		//cmd[cmd_len++]=0xA3;			//slave FIFO, IFCLK=30MHz, IFCLKo,  (Sync)[h
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

		if(!network){
			pFileWriter->OpenFile(tsfname);
		}

		if(sleep > 4){
			sleep -= 3;
			log_out("[L^JnԂ܂őҋ@܂]\n");
			Sleep(sleep * 1000);
		}

		//`lݒ
		if(ir_cmd_num != 0){
			ir_cmdtx(ir_cmd, ir_cmd_num);
//			Sleep(2500);
		}

		time_t stime = time(NULL);
		stm = localtime(&stime);
		log_out("%02d:%02d:%02d L^Jn܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);
/*
		// bcast@C쐬bcsL^X^[g15btsL^n܂悤ɂB
		if(bcas) {
			start_time = stime + GetPrivateProfileInt("TS_BUFFER","TS_START_MARGIN",5,VLC_INI_FILE);
		}
		else 
			start_time = stime;		// bcŝƂ͂tsL^n܂悤ɂB
*/
		start_time = stime;

		tcb1 = usb->start_thread(0x86, BUF_LEN, QUE_NUM, write_func);

		if(bcas){
			tcb2 = usb->start_thread(0x84, 512, 1, write_bcas);
		}

		cmd[cmd_len++]=CMD_EP6IN_START;
		if(bcas)
			cmd[cmd_len++]=CMD_EP4IN_START;
		cmd[cmd_len++]=CMD_PORT_WRITE;
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//START=1
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START=1
#endif
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		log_out("JIUSB FX2 -> PC L^\n");
		hRecvChkTh = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)recvchkthread_proc, NULL, 0, NULL);
		hCmdThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)cmdThread_proc, NULL, 0, NULL);
		usb->delete_thread(tcb1);
		if(bcas){
			usb->delete_thread(tcb2);
		}
		time_t etime = time(NULL);
		struct tm* etm = localtime(&etime);
		log_out("%02d:%02d:%02d L^I܂B\n",etm->tm_hour,etm->tm_min,etm->tm_sec);

		CloseHandle(hRecvChkTh);
		bCmdThreadStop = true;
		WaitForSingleObject(hCmdThread,1000);
		CloseHandle(hCmdThread);

		//dOFFp cap_stsIvpoffsȂ
		if(ir_post_cmd_num != 0 && !bStopEventRecv){
			ir_cmdtx(ir_post_cmd, ir_post_cmd_num);
//			Sleep(500);
		}

	}
	else{
		log_out("^[Qbg̃JIUSB FX2Fł܂B\n");
		if(retry_cnt++ < 6){
			Sleep(3000);
			goto RETRY;
		}
	}


	if(network){
		CloseVlc();
	}

	pEcm->exit();
	CloseHandle(hStopEvent);

	B25Exit();
	
	delete usb;

	if(tsfname)
		DoAfterCommand(tsfname,vlc_param);
	//dOFFp cap_stsIvpoffsȂ
	if(ir_post_cmd_num != 0 && !bStopEventRecv){
		DoSuspend();
	}

	return 0;
}

